Option Explicit On
Option Strict On

#Region " Inclusions "
Imports Bdt.Shared.Logs
Imports Bdt.Shared.Service
#End Region

Namespace Bdt.Client.Sockets

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Serveur pour les forwards 
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class GatewayServer
        Inherits TcpServer

#Region " Attributs "
        Protected m_tunnel As ITunnel
        Protected m_address As String
        Protected m_remoteport As Integer
        Protected m_uid As Integer
#End Region

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="localport">port local ct client</param>
        ''' <param name="shared">bind sur toutes les ip/ip locale</param>
        ''' <param name="remoteport">port distant ct serveur</param>
        ''' <param name="address">adresse ct serveur</param>
        ''' <param name="tunnel">tunnel de communication</param>
        ''' <param name="uid">user-id</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal localport As Integer, ByVal [shared] As Boolean, ByVal remoteport As Integer, ByVal address As String, ByVal tunnel As ITunnel, ByVal uid As Integer)
            MyBase.New(localport, [shared])
            Log(String.Format("Forward de {0}:{1} vers {2}:{3}", Ip, localport, address, remoteport), ILogger.ESeverity.DEBUG)

            m_tunnel = tunnel
            m_uid = uid
            m_address = address
            m_remoteport = remoteport
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Callback en cas de nouvelle connexion
        ''' </summary>
        ''' <param name="client">le socket client</param>
        ''' -----------------------------------------------------------------------------
        Protected Overrides Sub OnNewConnection(ByVal client As System.Net.Sockets.TcpClient)
            Dim gateway As New Gateway(client, m_tunnel, m_uid, m_address, m_remoteport)
        End Sub

    End Class

End Namespace
