Option Explicit On
Option Strict On

Namespace Bdt.Client.Socks

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Gestionnaire Socks v4A (avec DNS)
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class Socks4AHandler
        Inherits Socks4Handler

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le handler est-il adapt  la requte?
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Overrides ReadOnly Property IsHandled() As Boolean
            Get
                ' Prparation pessimiste de la rponse
                m_reply(0) = SOCKS4_REPLY_VERSION
                m_reply(1) = SOCKS4_KO
                Array.Clear(m_reply, 2, 6)

                If (Version <> 4) Then Return False

                ' Test du Socks4a
                If ((Buffer(4) = 0) AndAlso (Buffer(5) = 0) AndAlso (Buffer(6) = 0)) Then
                    If (Command <> SOCKS4_BIND_COMMAND) Then
                        RemotePort = 256 * Convert.ToInt32(Buffer(2)) + Convert.ToInt32(Buffer(3))
                        Dim position As Integer = -1
                        For i As Integer = 8 To Buffer.Length - 1
                            If Buffer(i) = 0 Then
                                position = i
                                Exit For
                            End If
                        Next
                        If position >= 0 Then
                            Address = New String(System.Text.Encoding.ASCII.GetChars(Buffer), position + 1, Buffer.Length - position - 2)
                        Else
                            Address = String.Empty
                        End If

                        ' Prparation de la rponse
                        m_reply(1) = SOCKS4_OK
                        Array.Copy(Buffer, 2, m_reply, 2, 2)
                        Array.Clear(m_reply, 4, 3)
                        m_reply(7) = Buffer(7)
                        Log("Requte Socks4A supporte", [Shared].Logs.ILogger.ESeverity.DEBUG)
                        Return True
                    Else
                        ' Socks4 BIND 
                        Log("Requte Socks4 BIND non supporte", [Shared].Logs.ILogger.ESeverity.WARN)
                    End If
                End If
                Return False
            End Get
        End Property
#End Region

#Region " Mthodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="buffer"></param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal buffer() As Byte)
            MyBase.New(buffer)
        End Sub
#End Region

    End Class
End Namespace