Option Explicit On 
Option Strict On

#Region " Inclusions "
Imports Bdt.Shared.Runtime
Imports Bdt.Shared.Logs
Imports Bdt.Server.Service
#End Region

Namespace Bdt.Server.Runtime

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Programme ct serveur du tunnel de communication
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class BdtServer
        Inherits Program

#Region " Mthodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Point d'entre du programme BdtClient
        ''' </summary>
        ''' <param name="args">les arguments de la ligne de commande</param>
        ''' -----------------------------------------------------------------------------
        Public Shared Sub Main(ByVal args As String())
            Dim server As New BdtServer
            server.Start(args)
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Traitement principal
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Protected Overrides Sub Run()
            Try
                Log(String.Format("-=[ BoutDuTunnel Serveur v{0} - SLE ]=-", Me.GetType.Assembly.GetName.Version), ILogger.ESeverity.INFO)
                Log(String.Empty, ILogger.ESeverity.INFO)
                Tunnel.Configuration = Configuration
                Protocol.ConfigureServer(GetType(Tunnel))
                Log("Serveur dmarr, appuyez sur une touche pour quitter...", ILogger.ESeverity.INFO)
                Console.ReadLine()
                Tunnel.DisableChecking()
            Catch ex As Exception
                Log(ex.Message, ILogger.ESeverity.ERROR)
            End Try
        End Sub
#End Region

    End Class

End Namespace