Option Explicit On 
Option Strict On

#Region " Inclusions "
Imports System.Net.Sockets
Imports Bdt.Shared.Service
Imports Bdt.Shared.Request
Imports Bdt.Shared.Response
#End Region

Namespace Bdt.Server.Service

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Une connexion au sein du tunnel
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class TunnelConnection

#Region " Attributs "
        Protected m_tcpClient As TcpClient
        Protected m_stream As NetworkStream
        Protected m_lastAccess As Date
        Protected m_uid As Integer
#End Region

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le client TCP associ
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property TcpClient() As TcpClient
            Get
                Return m_tcpClient
            End Get
            Set(ByVal Value As TcpClient)
                m_tcpClient = Value
            End Set
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le flux associ
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property Stream() As NetworkStream
            Get
                Return m_stream
            End Get
            Set(ByVal Value As NetworkStream)
                m_stream = Value
            End Set
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' La date de dernire opration I/O
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property LastAccess() As Date
            Get
                Return m_lastAccess
            End Get
            Set(ByVal Value As Date)
                m_lastAccess = Value
            End Set
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le user-id associ
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property Uid() As Integer
            Get
                Return m_uid
            End Get
            Set(ByVal Value As Integer)
                m_uid = Value
            End Set
        End Property

#End Region

    End Class

End Namespace