Option Explicit On
Option Strict On

#Region " Inclusions "
Imports System
Imports System.Runtime
#End Region

Namespace Bdt.Shared.Console

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Gestion de la console mode texte
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class ConsoleTools

#Region " Enumerations "
        Public Enum CONSOLE_INPUT_MODES As Integer
            ENABLE_PROCESSED_INPUT = &H1
            ENABLE_LINE_INPUT = &H2
            ENABLE_ECHO_INPUT = &H4
            ENABLE_WINDOW_INPUT = &H8
            ENABLE_MOUSE_INPUT = &H10
        End Enum

        Public Enum CONSOLE_OUTPUT_MODES As Integer
            ENABLE_PROCESSED_OUTPUT = &H1
            ENABLE_WRAP_AT_EOL_OUTPUT = &H2
        End Enum

        Public Enum CONSOLE_STANDARD_HANDLES As Integer
            STD_INPUT_HANDLE = -10
            STD_OUTPUT_HANDLE = -11
            STD_ERROR_HANDLE = -12
        End Enum

        Public Enum SHOW_FLAGS As Integer
            SW_HIDE = 0
            SW_SHOWNORMAL = 1
            SW_SHOWMINIMIZED = 2
            SW_MAXIMIZE = 3
            SW_SHOWMAXIMIZED = 3
            SW_SHOWNOACTIVATE = 4
            SW_SHOW = 5
            SW_MINIMIZE = 6
            SW_SHOWMINNOACTIVE = 7
            SW_RESTORE = 9
            SW_SHOWNA = 8
            SW_SHOWDEFAULT = 10
        End Enum
#End Region

#Region " Dclarations "
        Declare Function GetStdHandle Lib "kernel32.dll" (ByVal nStdHandle As CONSOLE_STANDARD_HANDLES) As IntPtr
        Declare Function GetConsoleMode Lib "kernel32.dll" (ByVal hConsoleHandle As IntPtr, ByRef lpMode As Integer) As Boolean
        Declare Function SetConsoleMode Lib "kernel32.dll" (ByVal hConsoleHandle As IntPtr, ByVal dwMode As Integer) As Boolean
        Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As IntPtr, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Integer) As Integer
        Declare Function GetLastError Lib "kernel32.dll" () As Integer
#End Region

    End Class

End Namespace
