Option Explicit On 
Option Strict On

#Region " Inclusions "
Imports Bdt.Shared.Configuration
#End Region

Namespace Bdt.Shared.Logs

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Gnration des logs sur le flux de sortie standard
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class ConsoleLogger
        Inherits BaseLogger

#Region " Mthodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur pour un log  partir des donnes fournies dans une configuration
        ''' </summary>
        ''' <param name="prefix">le prefixe dans la configuration ex: application/log</param>
        ''' <param name="config">la configuration pour la lecture des parametres</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal prefix As String, ByVal config As ConfigPackage)
            MyBase.New(System.Console.Out, prefix, config)
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur pour un log
        ''' </summary>
        ''' <param name="dateFormat">le format des dates de timestamp</param>
        ''' <param name="filter">le niveau de filtrage pour la sortie des logs</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(Optional ByVal dateFormat As String = DEFAULT_DATE_FORMAT, Optional ByVal filter As ILogger.ESeverity = ILogger.ESeverity.DEBUG)
            MyBase.New(System.Console.Out, dateFormat, filter)
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Fermeture du logger
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Overrides Sub Close()
            ' on ne fait rien pour ne pas fermer le stdout.
        End Sub

#End Region

    End Class

End Namespace