Option Explicit On 
Option Strict On

#Region " Inclusions "
Imports System.IO
Imports Bdt.Shared.Configuration
#End Region

Namespace Bdt.Shared.Logs

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Interface minimale pour la gnration d'un log 
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Interface ILogger

#Region " Enumerations "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Severit d'une entre de log, Filter permet de donner un niveau minimum
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Enum ESeverity
            DEBUG = 1
            INFO = 2
            WARN = 3
            [ERROR] = 4
            FATAL = 5
        End Enum
#End Region

#Region " Mthodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Ecriture d'une entre de log. Ne sera pas prise en compte si le log est inactif
        ''' ou si le filtre l'impose
        ''' </summary>
        ''' <param name="sender">l'emetteur</param>
        ''' <param name="message">le message  logger</param>
        ''' <param name="severity">la svrit</param>
        ''' -----------------------------------------------------------------------------
        Sub Log(ByVal sender As Object, ByVal message As String, ByVal severity As ESeverity)

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Fermeture du logger
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Sub Close()
#End Region

    End Interface

End Namespace
