Option Explicit On 
Option Strict On

#Region " Inclusions "
Imports System.Net
Imports System.Reflection
Imports System.Runtime.Remoting.Channels.Http
#End Region

Namespace Bdt.Shared.Protocol

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Protocole de communication bas sur le remoting .NET et sur le protocole HTTP
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public MustInherit Class GenericHttpRemoting
        Inherits GenericRemoting
        Implements IProxyCompatible

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' L'URL ncessaire pour se connecter au serveur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Protected Overrides ReadOnly Property ServerURL() As String
            Get
                Return String.Format("http://{0}:{1}/{2}", Address, Port, Name)
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le proxy utilis par le canal de communication ct client
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property Proxy() As System.Net.IWebProxy Implements IProxyCompatible.Proxy
            Get
                Dim clientChannelFieldInfo As FieldInfo = GetType(HttpChannel).GetField("_clientChannel", BindingFlags.Instance Or BindingFlags.NonPublic)
                Dim channel As HttpClientChannel = DirectCast(clientChannelFieldInfo.GetValue(ClientChannel), HttpClientChannel)
                Dim proxyObjectFieldInfo As FieldInfo = GetType(HttpClientChannel).GetField("_proxyObject", BindingFlags.Instance Or BindingFlags.NonPublic)
                Return DirectCast(proxyObjectFieldInfo.GetValue(channel), IWebProxy)
            End Get
            Set(ByVal Value As System.Net.IWebProxy)
                Dim clientChannelFieldInfo As FieldInfo = GetType(HttpChannel).GetField("_clientChannel", BindingFlags.Instance Or BindingFlags.NonPublic)
                Dim channel As HttpClientChannel = DirectCast(clientChannelFieldInfo.GetValue(ClientChannel), HttpClientChannel)
                Dim proxyObjectFieldInfo As FieldInfo = GetType(HttpClientChannel).GetField("_proxyObject", BindingFlags.Instance Or BindingFlags.NonPublic)
                proxyObjectFieldInfo.SetValue(channel, Value)
            End Set
        End Property
#End Region

    End Class

End Namespace
