Option Explicit On 
Option Strict On

#Region " Inclusions "
Imports System.Net
Imports System.Runtime.Remoting.Channels
Imports System.Runtime.Remoting.Channels.Http
#End Region

Namespace Bdt.Shared.Protocol

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Protocole de communication bas sur le remoting .NET et sur le protocole HTTP
    ''' Utilise un formateur binaire pour les donnes
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class HttpBinaryRemoting
        Inherits GenericHttpRemoting

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le canal de communication ct client
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Overrides ReadOnly Property ClientChannel() As System.Runtime.Remoting.Channels.IChannel
            Get
                Static channel As New HttpChannel(Nothing, New BinaryClientFormatterSinkProvider, Nothing)
                Return channel
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le canal de communication ct serveur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Protected Overrides ReadOnly Property ServerChannel() As System.Runtime.Remoting.Channels.IChannel
            Get
                Dim properties As New Hashtable
                properties(CFG_NAME) = String.Format("{0}Channel", Name)
                properties(CFG_PORT) = Port.ToString
                Static channel As New HttpChannel(properties, Nothing, New BinaryServerFormatterSinkProvider)
                Return channel
            End Get
        End Property
#End Region

    End Class

End Namespace
