Option Explicit On 
Option Strict On

#Region " Inclusions "
Imports System.Runtime.Remoting.Channels.Http
#End Region

Namespace Bdt.Shared.Protocol

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Protocole de communication bas sur le remoting .NET et sur le protocole HTTP
    ''' Utilise un formateur SOAP pour les donnes
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class HttpSoapRemoting
        Inherits GenericHttpRemoting

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le canal de communication ct client
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Overrides ReadOnly Property ClientChannel() As System.Runtime.Remoting.Channels.IChannel
            Get
                Static channel As New HttpChannel
                Return channel
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le canal de communication ct serveur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Protected Overrides ReadOnly Property ServerChannel() As System.Runtime.Remoting.Channels.IChannel
            Get
                Static channel As New HttpChannel(Port)
                Return channel
            End Get
        End Property
#End Region

    End Class

End Namespace
