Option Explicit On 
Option Strict On

#Region " Inclusions "
Imports System.Runtime.Remoting.Channels.Ipc
#End Region

Namespace Bdt.Shared.Protocol

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Protocole de communication bas sur le remoting .NET et sur le protocole IPC
    ''' Exclusivement pour une communication sur la mme machine (client/serveur)
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class IpcRemoting
        Inherits GenericRemoting

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le canal de communication ct client
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Overrides ReadOnly Property ClientChannel() As System.Runtime.Remoting.Channels.IChannel
            Get
                Static channel As New IpcChannel
                Return channel
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le canal de communication ct serveur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Protected Overrides ReadOnly Property ServerChannel() As System.Runtime.Remoting.Channels.IChannel
            Get
                Static channel As New IpcChannel(Name)
                Return channel
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' L'URL ncessaire pour se connecter au serveur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Protected Overrides ReadOnly Property ServerURL() As String
            Get
                Return String.Format("ipc://{0}/{0}", Name, Name)
            End Get
        End Property
#End Region

    End Class

End Namespace
