Option Explicit On 
Option Strict On

#Region " Inclusions "
Imports System.Runtime.Remoting.Channels.Tcp
#End Region

Namespace Bdt.Shared.Protocol

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Protocole de communication bas sur le remoting .NET et sur le protocole TCP
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Class TcpRemoting
        Inherits GenericRemoting

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le canal de communication ct client
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Overrides ReadOnly Property ClientChannel() As System.Runtime.Remoting.Channels.IChannel
            Get
                Static channel As New TcpChannel
                Return channel
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le canal de communication ct serveur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Protected Overrides ReadOnly Property ServerChannel() As System.Runtime.Remoting.Channels.IChannel
            Get
                Static channel As New TcpChannel(Port)
                Return channel
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' L'URL ncessaire pour se connecter au serveur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Protected Overrides ReadOnly Property ServerURL() As String
            Get
                Return String.Format("tcp://{0}:{1}/{2}", Address, Port, Name)
            End Get
        End Property
#End Region

    End Class

End Namespace
