Option Explicit On 
Option Strict On

Namespace Bdt.Shared.Request

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Une demande d'authentification
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    <Serializable()> _
    Public Class AuthenticateRequest
        Inherits GenericRequest

#Region " Attributs "
        Protected m_username As String
        Protected m_password As String
#End Region

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le nom de l'utilisateur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property Username() As String
            Get
                Return m_username
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le mot de passe de l'utilisateur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property Password() As String
            Get
                Return m_password
            End Get
        End Property
#End Region

#Region " Methodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="username">Le nom de l'utilisateur</param>
        ''' <param name="password">Le mot de passe de l'utilisateur</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal username As String, ByVal password As String)
            m_username = username
            m_password = password
        End Sub
#End Region

    End Class

End Namespace
