Option Explicit On 
Option Strict On

Namespace Bdt.Shared.Request

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Une demande de connexion
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    <Serializable()> _
    Public Class ConnectRequest
        Inherits GenericRequest

#Region " Attributs "
        Protected m_address As String
        Protected m_port As Integer
#End Region

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' L'adresse distante
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property Address() As String
            Get
                Return m_address
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le port distant
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property Port() As Integer
            Get
                Return m_port
            End Get
        End Property
#End Region

#Region " Methodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="uid">Le jeton utilisateur</param>
        ''' <param name="address">L'adresse distante</param>
        ''' <param name="port">Le port distant</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal uid As Integer, ByVal address As String, ByVal port As Integer)
            MyBase.New(uid, -1)
            m_address = address
            m_port = port
        End Sub
#End Region

    End Class

End Namespace
