Option Explicit On 
Option Strict On

Namespace Bdt.Shared.Request

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Une demande gnrique
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    <Serializable()> _
    Public Class GenericRequest

#Region " Attributs "
        Protected m_cid As Integer
        Protected m_uid As Integer
#End Region

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le jeton de connexion
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property Cid() As Integer
            Get
                Return m_cid
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le jeton utilisateur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property Uid() As Integer
            Get
                Return m_uid
            End Get
        End Property
#End Region

#Region " Methodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Sub New()
            m_uid = -1
            m_cid = -1
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="uid">Le jeton utilisateur</param>
        ''' <param name="cid">Le jeton de connexion</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal uid As Integer, ByVal cid As Integer)
            m_uid = uid
            m_cid = cid
        End Sub
#End Region

    End Class

End Namespace

