Option Explicit On 
Option Strict On

Namespace Bdt.Shared.Response

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Une rponse d'authentification
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    <Serializable()> _
    Public Class AuthenticateResponse
        Inherits GenericResponse

#Region " Attributs "
        Protected m_uid As Integer = -1
#End Region

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le jeton utilisateur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property Uid() As Integer
            Get
                Return m_uid
            End Get
        End Property
#End Region

#Region " Methodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="success">Authentification russie/choue</param>
        ''' <param name="message">Le message d'information</param>
        ''' <param name="uid">Le jeton utilisateur affect</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal success As Boolean, ByVal message As String, ByVal uid As Integer)
            MyBase.New(success, message)
            m_uid = uid
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="success">Authentification russie/choue</param>
        ''' <param name="uid">Le jeton utilisateur affect</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal success As Boolean, ByVal uid As Integer)
            MyBase.New(success)
            m_uid = uid
        End Sub
#End Region

    End Class

End Namespace

