Option Explicit On 
Option Strict On

Namespace Bdt.Shared.Response

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Une rponse de connexion
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    <Serializable()> _
    Public Class ConnectResponse
        Inherits GenericResponse

#Region " Attributs "
        Protected m_cid As Integer = -1
#End Region

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le jeton de connexion affect
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property Cid() As Integer
            Get
                Return m_cid
            End Get
            Set(ByVal value As Integer)
                m_cid = value
            End Set
        End Property
#End Region

#Region " Methodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Sub New()
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="success">La connexion a aboutie/chou</param>
        ''' <param name="message">Le message d'information</param>
        ''' <param name="cid">Le jeton de connexion affect</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal success As Boolean, ByVal message As String, ByVal cid As Integer)
            MyBase.New(success, message)
            m_cid = cid
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="success">La requte a aboutie/chou</param>
        ''' <param name="cid">Le jeton de connexion affect</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal success As Boolean, ByVal cid As Integer)
            MyBase.New(success)
            m_cid = cid
        End Sub
#End Region



    End Class

End Namespace

