Option Explicit On 
Option Strict On

Namespace Bdt.Shared.Response

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Une connexion au sein du tunnel
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    <Serializable()> _
    Public Class Connection

#Region " Attributs "
        Protected m_username As String
        Protected m_cid As Integer
        Protected m_endPoint As String
        Protected m_lastAccess As Date
        Protected m_dataAvailable As Boolean
#End Region

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le nom de l'utilisateur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property Username() As String
            Get
                Return m_username
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le jeton de connexion
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property Cid() As Integer
            Get
                Return m_cid
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le noeud distant ip:port
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property EndPoint() As String
            Get
                Return m_endPoint
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' La date de dernire opration I/O
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property LastAccess() As Date
            Get
                Return m_lastAccess
            End Get
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Des donnes sont-elles disponibles?
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public ReadOnly Property DataAvailable() As Boolean
            Get
                Return m_dataAvailable
            End Get
        End Property
#End Region

#Region " Methodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="username">Le nom de l'utilisateur</param>
        ''' <param name="cid">Le jeton de connexion</param>
        ''' <param name="endPoint">Le noeud distant ip:port</param>
        ''' <param name="lastAccess">La date de dernire opration I/O</param>
        ''' <param name="dataAvailable">Des donnes sont-elles disponibles?</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal username As String, ByVal cid As Integer, ByVal endPoint As String, ByVal lastAccess As Date, ByVal dataAvailable As Boolean)
            m_username = username
            m_cid = cid
            m_endPoint = endPoint
            m_lastAccess = lastAccess
            m_dataAvailable = dataAvailable
        End Sub
#End Region

    End Class

End Namespace

