Option Explicit On 
Option Strict On

Namespace Bdt.Shared.Response

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Une rponse d'numeration des connexions
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    <Serializable()> _
    Public Class ConnectionsResponse
        Inherits GenericResponse

#Region " Attributs "
        Protected m_connections As Connection() = Nothing
#End Region

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Les connexions
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property Connections() As Connection()
            Get
                Return m_connections
            End Get
            Set(ByVal value As Connection())
                m_connections = value
            End Set
        End Property
#End Region

#Region " Methodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Sub New()
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="success">La requte a aboutie/chou</param>
        ''' <param name="message">Le message d'information</param>
        ''' <param name="connections">Les connexions</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal success As Boolean, ByVal message As String, ByVal connections As Connection())
            MyBase.New(success, message)
            m_connections = connections
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="success">La requte a aboutie/chou</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal success As Boolean)
            MyBase.New(success)
        End Sub
#End Region




    End Class

End Namespace

