Option Explicit On 
Option Strict On

Namespace Bdt.Shared.Response

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Une rponse gnrique
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    <Serializable()> _
    Public Class GenericResponse

#Region " Attributs "
        Protected m_success As Boolean = False
        Protected m_message As String = String.Empty
        Protected m_dataAvailable As Boolean
        Protected m_connected As Boolean
#End Region

#Region " Proprietes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Des donnes sont-elles disponibles?
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property DataAvailable() As Boolean
            Get
                Return m_dataAvailable
            End Get
            Set(ByVal value As Boolean)
                m_dataAvailable = value
            End Set
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' La connexion est-elle effective?
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property Connected() As Boolean
            Get
                Return m_connected
            End Get
            Set(ByVal value As Boolean)
                m_connected = value
            End Set
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' La requte a aboutie/chou ?
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property Success() As Boolean
            Get
                Return m_success
            End Get
            Set(ByVal Value As Boolean)
                m_success = Value
            End Set
        End Property

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Le message d'information
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Property Message() As String
            Get
                Return m_message
            End Get
            Set(ByVal Value As String)
                m_message = Value
            End Set
        End Property
#End Region

#Region " Methodes "
        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' -----------------------------------------------------------------------------
        Public Sub New()
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="success">La requte a aboutie/chou ?</param>
        ''' <param name="message">Le message d'information</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal success As Boolean, ByVal message As String)
            m_success = success
            m_message = message
            m_dataAvailable = False
            m_connected = False
        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Constructeur
        ''' </summary>
        ''' <param name="success">La requte a aboutie/chou ?</param>
        ''' -----------------------------------------------------------------------------
        Public Sub New(ByVal success As Boolean)
            m_success = success
            m_dataAvailable = False
            m_connected = False
        End Sub
#End Region

    End Class

End Namespace

