Option Explicit On 
Option Strict On

Imports Bdt.Shared.Request
Imports Bdt.Shared.Response

Namespace Bdt.Shared.Service

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Les services proposs par une instance de Tunnel
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Interface ITunnel

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Authentification d'un utilisateur
        ''' </summary>
        ''' <param name="request">la requte</param>
        ''' <returns>une rponse AuthenticateResponse avec un uid</returns>
        ''' -----------------------------------------------------------------------------
        Function Authenticate(ByVal request As AuthenticateRequest) As AuthenticateResponse

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' La version du serveur
        ''' </summary>
        ''' <returns>La version de l'assembly</returns>
        ''' -----------------------------------------------------------------------------
        Function Version() As GenericResponse

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Etablissement d'une nouvelle connexion
        ''' </summary>
        ''' <param name="request">la requte</param>
        ''' <returns>le cid de connexion</returns>
        ''' -----------------------------------------------------------------------------
        Function Connect(ByVal request As ConnectRequest) As ConnectResponse

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Dconnexion
        ''' </summary>
        ''' <param name="request">la requte</param>
        ''' <returns>une reponse gnrique</returns>
        ''' -----------------------------------------------------------------------------
        Function Disconnect(ByVal request As GenericRequest) As GenericResponse

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Lecture de donnes
        ''' </summary>
        ''' <param name="request">la requte</param>
        ''' <returns>les donnes lues dans response.Data</returns>
        ''' -----------------------------------------------------------------------------
        Function Read(ByVal request As GenericRequest) As ReadResponse

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Ecriture de donnes
        ''' </summary>
        ''' <param name="request">la requte</param>
        ''' <returns>une rponse gnrique</returns>
        ''' -----------------------------------------------------------------------------
        Function Write(ByVal request As WriteRequest) As GenericResponse

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Retourne l'tat d'une connexion
        ''' </summary>
        ''' <param name="request">la requte</param>
        ''' <returns>Une rponse gnrique</returns>
        ''' -----------------------------------------------------------------------------
        Function State(ByVal request As GenericRequest) As GenericResponse

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' Retourne des informations sur les connexions tablies
        ''' </summary>
        ''' <param name="request">la requte</param>
        ''' <returns>la liste des connexions</returns>
        ''' -----------------------------------------------------------------------------
        Function Connections(ByVal request As GenericRequest) As ConnectionsResponse

    End Interface

End Namespace

